defmodule StepFlow.Migration.AddJobAndWorkflowLastStatusId do
  use Ecto.Migration
  @moduledoc false

  def change do
    alter table(:step_flow_jobs) do
      add(:last_status_id, :integer)
    end

    execute("UPDATE step_flow_jobs
       SET last_status_id = subquery.max_id
       FROM (SELECT job_id, max(id) as max_id FROM step_flow_status GROUP BY job_id) AS subquery
       WHERE step_flow_jobs.id = job_id")

    alter table(:step_flow_workflow) do
      add(:last_status_id, :integer)
    end

    execute("UPDATE step_flow_workflow
       SET last_status_id = subquery.max_id
       FROM (SELECT workflow_id, max(id) as max_id FROM step_flow_workflow_status GROUP BY workflow_id) AS subquery
       WHERE step_flow_workflow.id = workflow_id")
  end
end
